<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLinhasInternosStatusERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLinhasInternosStatusERP
 * @subpackage Arrays
 */
class ArrayOfLinhasInternosStatusERP extends AbstractStructArrayBase
{
    /**
     * The LinhasInternosStatusERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LinhasInternosStatusERP[]
     */
    public $LinhasInternosStatusERP;
    /**
     * Constructor method for ArrayOfLinhasInternosStatusERP
     * @uses ArrayOfLinhasInternosStatusERP::setLinhasInternosStatusERP()
     * @param \StructType\LinhasInternosStatusERP[] $linhasInternosStatusERP
     */
    public function __construct(array $linhasInternosStatusERP = array())
    {
        $this
            ->setLinhasInternosStatusERP($linhasInternosStatusERP);
    }
    /**
     * Get LinhasInternosStatusERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LinhasInternosStatusERP[]|null
     */
    public function getLinhasInternosStatusERP()
    {
        return isset($this->LinhasInternosStatusERP) ? $this->LinhasInternosStatusERP : null;
    }
    /**
     * Set LinhasInternosStatusERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LinhasInternosStatusERP[] $linhasInternosStatusERP
     * @return \ArrayType\ArrayOfLinhasInternosStatusERP
     */
    public function setLinhasInternosStatusERP(array $linhasInternosStatusERP = array())
    {
        foreach ($linhasInternosStatusERP as $arrayOfLinhasInternosStatusERPLinhasInternosStatusERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfLinhasInternosStatusERPLinhasInternosStatusERPItem instanceof \StructType\LinhasInternosStatusERP) {
                throw new \InvalidArgumentException(sprintf('The LinhasInternosStatusERP property can only contain items of \StructType\LinhasInternosStatusERP, "%s" given', is_object($arrayOfLinhasInternosStatusERPLinhasInternosStatusERPItem) ? get_class($arrayOfLinhasInternosStatusERPLinhasInternosStatusERPItem) : gettype($arrayOfLinhasInternosStatusERPLinhasInternosStatusERPItem)), __LINE__);
            }
        }
        if (is_null($linhasInternosStatusERP) || (is_array($linhasInternosStatusERP) && empty($linhasInternosStatusERP))) {
            unset($this->LinhasInternosStatusERP);
        } else {
            $this->LinhasInternosStatusERP = $linhasInternosStatusERP;
        }
        return $this;
    }
    /**
     * Add item to LinhasInternosStatusERP value
     * @throws \InvalidArgumentException
     * @param \StructType\LinhasInternosStatusERP $item
     * @return \ArrayType\ArrayOfLinhasInternosStatusERP
     */
    public function addToLinhasInternosStatusERP(\StructType\LinhasInternosStatusERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LinhasInternosStatusERP) {
            throw new \InvalidArgumentException(sprintf('The LinhasInternosStatusERP property can only contain items of \StructType\LinhasInternosStatusERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LinhasInternosStatusERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LinhasInternosStatusERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LinhasInternosStatusERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LinhasInternosStatusERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LinhasInternosStatusERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LinhasInternosStatusERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LinhasInternosStatusERP
     */
    public function getAttributeName()
    {
        return 'LinhasInternosStatusERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLinhasInternosStatusERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
